c---------------------------------------------------------------------
      subroutine lgauss(xg,wg,ngmax)
C       generation of legendre-gauss mesh points and weights
C          input:  ngmax
C          output: xg, wg
c---------------------------------------------------------------------
      implicit real*8(a-h,o-z)
c
      dimension xg(*),wg(*)
      dimension fldr(151)
      real*4 xg,wg
C
      real*8 cpi/3.141592654d0/
      data eps/1.d-12/
C
      fn=ngmax
      ds=CPI/(fn+0.5d0)
      s1=-0.25d0*ds
      l1max=ngmax+1
      ngmax2=ngmax-ngmax/2
      do 100 k=1,ngmax2
        s1=s1+ds
        x0=dcos(s1)
        do 50 i=1,999
C----------------------------------------------------------------------
          CALL LGDR(x0,fldr,l1max)
C          input:  x, l1max
C          output: fldr
C----------------------------------------------------------------------
          pnm1=fldr(ngmax)
          pn  =fldr(l1max)
          pnd=fn*(pnm1-x0*pn)/(1.d0-x0*x0)
          x1=x0-pn/pnd
C----------------------------------------------------------------------
          if(dabs(x0-x1).lt.eps) goto 60
C----------------------------------------------------------------------
          x0=x1
   50   continue
   60   wght=2.d0*(1.d0-x1*x1)/(fn*fn*pnm1*pnm1)
        kmg=ngmax-k+1
        xg(kmg)=x1
        xg(k)=-x1
        wg(kmg)=wght
        wg( k )=wght
  100 continue
      return
      end
