c======================================================================
      PROGRAM MAIN
c   CONTINUUM RPA+DWIA+M*+RWD CALCULATION
c======================================================================
c       cnvcm     : convergence check index for RS
c       cnvvm,   : convergence check index for RV
c======================================================================
      include 'dimn.fh'
      include 'ndp.fh'
      include 'fund1.fh'
      include 'fund2.fh'
      include 'cntl.fh'
      include 'opep.fh'
      include 'space.fh'
      include 'grpaj.fh'
      include 'veffct.fh'
      include 'rsrtrl.fh'
      include 'base.fh'
      include 'theta.fh'
      include 'drive.fh'
      include 'lgbs.fh'
      include 'weff.fh'
c
      real*4 ENNd(nwdm,nandm),qcmd(nwdm,nandm)
      real*4 ampcm2(5),ampcm2d(5,nwdm,nandm)
      real*4 omegd(nwdm),qintd(nwdm)
      real*4 wgt(nrdm),tmasx(2)
      real*4 respT(nwdm), respL(nwdm)
      integer Jconv(nwdm)
      complex bzero(nsrdm*2*2,nsrdm*2*2,2,2,2,2)
      complex tzffr(2,nsrdm*2,nsrdm*2,2,2,2,2)
c
      real*8 cpi/3.141592654d0/
C======================================================================
c  *** INPUT 
      CALL INPUT0(epsj,Vtautau,knmin,knmax,prmass,ejmass,tgmass,
     &     EFL,WSHIFT,difm,thetlmn,dthetl,omglmn,domegl,IRUMAX,
     &     lparmn,lparmx,KTLTR,obex)
C======================================================================
C   *** OUTPUT INPUT DATA
      CALL WRITE0(EPSJ,Vtautau,knmin,knmax,prmass,ejmass,tgmass,
     &     EFL,WSHIFT,thetlmn,dthetl,omglmn,domegl,
     &     lparmn,lparmx,KTLTR,obex)
C=====================================================================
C   *** SET WEIGHT OF RADIAL INTEGRATION (SIMPSON'S INTEGRAL)
      CALL WEIGHT(wgt,dsr,nsrmax,nrdm)      
c======================================================================
C   *** LEGENDRE-GAUSS MESH POINTS & SHPERICAL BESSEL FUNC. ***
      CALL LGSBSL
C===================================================================
C   *** WOODS-SAXON BOUND STATE W.F.: ci(nr,(sp.no1,sp.no2)) ***
      CALL BOUND
      CALL WBOUND(KTOUT_BDW,NRMAX) 
C==================================================================
C   PREPARE FACLOG(N)=LOG((N-1)!)
      call stfclg
C==================================================================
c   DO LOOP OF SCATTERING ANGLES
c====================================================================
      do 6000 nan=1,nanmax
C====================================================================
c   DO LOOP OF Transferred Energy OMEGA(L)
c====================================================================
      do 5000 nw=1,nwmax
      omegl = omegld(nw)
C======================================================================
C     for DWIA
C=====================================================================
c   Set basic data for DWIA
c---------------------------------------------------------------------
      CALL BASIC3(nan,omegl,prmass,ejmass,tgmass,EFL,energy,
     &     qcm,q_int,fmoel,fcm2l,ampcm2,sintq,th_c_rad,    
     &     sval,tmasx,lparmn,lparmx)
C======================================================================
        omeg =tmasx(2)-tmasx(1)-wshift
        omegd(nw) = omeg
        qintd(nw) = q_int
        ENNd(nw,nan)  = energy
        qcmd(nw,nan)  = qcm
        do namp=1,5
        ampcm2d(namp,nw,nan)= ampcm2(namp)
        end do
c===================================================================
C   INITIALIZATION of grpa2 for the given q_int and omeg
      do NDM=1,3
         do jtr=1,itrjmx
            do ip=1,2
               do kls=1,4
                  grpa2(jtr,ip,kls,NDM)=(0.0,0.0)
               end do
            end do
         end do
      end do
c=====================================================================
C   INITIALIZATION of RPS,RPSV,RPL for the given q_int and omeg
         rps(nw)=0.0
         do NDM=1,3
            rpl(nw,NDM) =0.0
            rpv(nw,NDM)=0.0
         end do
c=====================================================================
C   *** Effective interaction in q representation ***
      if(KTRPA.ne.0) then
         CALL  weffq(wefflq,wefftq,omeg,NDPMIN,NDPMAX,nkmax,
     &               fkdmsh,nkdm,obex) 
      end if
c======================================================================
c   { DO LOOP of ITRJ (transfer J)
c---------------------------------------------------------------------
      do 1000 itrjd=itrjmn,itrjmx
C----------------------------------------------------------------------
C    { DO LOOP OF PARITY
c     ip = 1: natural parity
c        = 2: unnatural parity
c----------------------------------------------------------------------
        do 980 ip=knmin,knmax
          iparit=ip
          kltrmx=ip
          if(KTLTR.eq.1)  kltrmx=1
          ltr(1)=itrjd-(ip-1)
          ltr(2)=itrjd+(ip-1)
          kstrmn=ip
          kstrmx=2
          if(itrjd.eq.0) then
            kltrmx=1
            ltr(1)=ip-1
            ltr(2)=ip-1
            kstrmx=ip
          end if
c
        ndmax=nsrmax*kltrmx
c
C       *** EFFECTIVE POTENTIAL: vff((r1,l1),(r2,l2)) ***
          if(KTRPA.ne.0) then
            CALL VEFFSV(itrjd,omeg,vff,wefflq,wefftq)
          endif
C----------------------------------------------------------------
C       *** p-h GREEN'S FUNC.: bzero((r1,l1),(r2,l2)) ***
          CALL SLFZR(itrjd,omeg,ndmax,difm,bzero)
C----------------------------------------------------------------
C   POLARIZATION PROPAGATER: tzffr((r1,l1),(r2,l2)) 
C
      do KNDP2=1,2
      do KNDP1=1,2
        do Kist2=1,2
        do Kist1=1,2
          do Kn2=1,2*nsrdm
          do Kn1=1,2*nsrdm
            do KIRU=1,2
              tzffr(KIRU,Kn1,Kn2,Kist1,Kist2,KNDP1,KNDP2)=(0.0,0.0)
            end do
          end do  
          end do
        end do
        end do
      end do
      end do
C
C   DO LOOP OF TRANSFERRED SPIN 
      do 190 ist2=kstrmn,kstrmx
      do 180 ist1=kstrmn,kstrmx
c
c   NO CORRELATION
       do iru=1,irumax
       CALL NONRPA(ist1,ist2,tzffr,iru,ndmax,NDPMIN,NDPMAX,bzero,nsrdm)
       end do
C
C   WITH CORRELATIONS
        if(KTRPA.ne.0) then
C    ISOVECTOR SPIN-SCALAR CHANNEL
          if(ist1.eq.1.and.ist2.eq.1) then
          call coupless(nsrdm,nsrmax,dsr,tzffr,bzero,wgt,Vtautau)
C    ISOVECTOR SPIN-VECTOR CHANNEL
          else if(ist1.eq.2.and.ist2.eq.2) then
           CALL COUPLESV(ndmax,tzffr,vff,bzero,wgt,
     &           NDPMIN,NDPMAX,nsrmax)
          endif
        endif
C
  180 continue ! End of transferred spin do loop (s1)
  190 continue ! End of transferred spin do loop (s2)
C-------------------------------------------------------------------- 
C  RESPONSE FUNCTION IN R REPRESENTATION: rffr(r1,r2)
          CALL COUPLE2(itrjd,NW,tzffr,
     &                 nsrmax,IRUMAX,NDPMIN,NDPMAX,NDMMAX)
c
C===================================================================   
C  RESPONSE FUNCTIONS IN q REPRESENTATION
C   DIAGONAL PART: grpa2(j,pi,l1,s1,l2,s2,q,w;U/C) 
      if(KTRQCV.ne.4)
     &   CALL GQQ(itrjd,q_int,wgt,tzffr,grpa2,
     &           IRUMAX,NDPMIN,NDPMAX,nsrmax,dsr)

c--------------------------------------------------------------------
  980 CONTINUE  ! End of parity do loop
C===================================================================   
C  RESPONSE FUNCTIONS IN q REPRESENTATION
c-------------------------------------------------------------------- 
      itrjmx1=itrjd
      if(KTRQCV.ne.4) then
         call  RSRTRL(nw,grpa2,itrjd,cnvcm,cnvvm,cnvlm,NDMMAX)
C-------------------------------------------------------------------
C  Convergence Check with respect to transferred J sum
         if(KTRQCV.eq.0) go to 1000
         if(KTRQCV.eq.1) cnv=max(cnvcm,cnvvm)
         if(KTRQCV.eq.2) cnv=cnvcm
         if(KTRQCV.eq.3) cnv=cnvvm
c
         if((cnv.ge.epsj/1000.0).and.(cnv.le.epsj)) then
            Jconv(nw)=itrjd
            goto 2000
         else
            Jconv(nw)=0
         end if
c--------------------------------------------------------------------
      end if
C=====================================================================
 1000 CONTINUE  !End of Jtr do loop
 2000 continue  !Exit point after Convergence Check
      IF(KTDW.EQ.2) GO TO 5000
C
C*************************************************************
C   DWIA Calculation
C*************************************************************
C
      NDMT=1
      if(NDMMAX.eq.3) NDMT=4
      ltrmx=itrjmx1+2
C------------------------------------------------------------------------
C    CALC. of DRIVING FORCE: vll=v(r1,r2,l1,nl2,exctyp); nl2=1 -> l2=l1 
C------------------------------------------------------------------------    
      IF(KTTNN.EQ.0) THEN
         CALL VDRLL(ltrmx,fmoel)
      ELSE IF(KTTNN.EQ.1) THEN 
         CALL VDRLL_FL(ltrmx,EFL)
      END IF
C-----------------------------------------------------------------------
      CALL AMPCLA(nan,nw,NDMT,knmin,knmax,itrjmx1,wgt,
     &     th_c_rad,sintq,sval,tmasx,lparmn,lparmx)
      CALL   XPOL(nan,nw,NDMT,knmin,knmax,
     &     itrjmn,itrjmx1,fcm2l,ampcm2(4),ampcm2(5))
c==================================================================
c  End of omega do loop
c------------------------------------------------------------------
 5000 continue
c==================================================================
C  OUTPUT Cross sections, P, Ay, Dij
C-----------------------------------------------------------------
      call  wxpol(nan,nwmax,thetld,omegld,NDMT,
     &            KTOUT_XS,KTOUT_LTRATIO)
c==================================================================
C  OUTPUT CONVERGENCE CHECK INFORMATION AND RESPONSE FUNCTIONS
C-----------------------------------------------------------------
      if(KTRQCV.ne.4) then
C   CONVERGENCE CHECK INFORMATION
        if(KTRQCV.ne.0) then
         call  WCONV(Jconv,nwmax,omegd)
        end if
C========================================================================
C   RESPONSE FUNCTIONS R(q,w) OUTPUT
C     Calculate full response functions and sum rule values and
C     Output them
C------------------------------------------------------------------------
        if(KTOUT_RQ.ne.0) then 
        CALL WRESP(qintd,fratio,omegd,NDMMAX,nwmax,KTRPA,respT,respL)
        end if
C      end if
C========================================================================
C   OUTPUT CROSS SECTION-RESPONSE FUNCTION RATIO
C------------------------------------------------------------------------
        if(KTOUT_PROP.ne.0) then 
        CALL WXRPROP(nan,NDMT,nwmax,omegld,KTRPA,respT,respL)
        end if
      end if
c==================================================================
C  OUTPUT |E|^2 and |F|^2 at q_cm for the given E_NN
c------------------------------------------------------------------
      if(KTOUT_NNA.ne.0) then 
         call wNNamp(nan,nwmax,thetld,omegld,ENNd,qcmd,ampcm2d)
      end if
c==================================================================
 6000 continue   !End of angle do loop
c==================================================================
 9999 stop
      end
