c ---------------------------------------------------------------------
      complex function spcp(n,u,x,y,b,c,d)
c---------------------------------------------------------------------
c  Evaluate the splined complex function y(u)
c  Originally coded by Ulich Goetz, Latest update by M.I. 2013.8.28
c----------------------------------------------------------------------
c  INPUT from argument
c     n: number of given points
c     u: real variable u at which the function y(u) is evaluated.
c     x(n): table of the given point coordinates,x_i (i=1...n)
c     y(n): table of the complex function values y(x_i)
c     b(n): table of the spline parameters for the 1st order at x_i
c     c(n): table of the spline parameters for the 2nd order at x_i
c     d(n): table of the spline parameters for the 3rd order at x_i
c  OUTPUT to the complex function value
c     spcp:  evaluated value of y(u)    
c ---------------------------------------------------------------------
      implicit none
      integer n
      real x(n),u,dx
      complex y(n),b(n),c(n),d(n)
      integer i,j,k
c
      i = 1
      if(u.lt.x(i))go to 10
      if(u.le.x(i+1))go to 30
10    i=1
      j=n+1
20    k=(i+j)/2
      if(u.lt.x(k))j=k
      if(u.ge.x(k))i=k
      if(j.gt.i+1)go to 20
30    dx=u-x(i)
      spcp=y(i)+dx*(b(i)+dx*(c(i)+dx*d(i)))
      return
      end
